Package net.sf.saxon.expr.instruct

## Class ComputedAttribute

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.SimpleNodeConstructor
      - - net.sf.saxon.expr.instruct.AttributeCreator
        - - net.sf.saxon.expr.instruct.ComputedAttribute

- All Implemented Interfaces:
    `ExportAgent`, `TailCallReturner`, `ValidatingInstruction`, `Locatable`, `IdentityComparable`, `Traceable`

      public final class ComputedAttribute
      extends AttributeCreator

  An instruction derived from an xsl:attribute element in stylesheet, or from an attribute constructor in XQuery, in cases where the attribute name is not known statically

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.instruct.SimpleNodeConstructor

      `selectOp`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ComputedAttribute​(Expression attributeName, Expression namespace, NamespaceResolver nsContext, int validationAction, SimpleType schemaType, boolean allowNameAsQName)` | Construct an Attribute instruction

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `checkPermittedContents​(SchemaType parentType, boolean whole)` | Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
    `int` | `computeSpecialProperties()` | Get the static properties of this expression (other than its type).
    `Expression` | `copy​(RebindingMap rebindings)` | Copy an expression.
    `Item` | `evaluateItem​(XPathContext context)` | Evaluate as an expression.
    `NodeName` | `evaluateNodeName​(XPathContext context)` | Determine the name to be used for the attribute, as an integer name code
    `void` | `export​(ExpressionPresenter out)` | Diagnostic print of expression structure.
    `int` | `getCardinality()` | Get the static cardinality of this expression
    `int` | `getInstructionNameCode()` | Get the name of this instruction
    `ItemType` | `getItemType()` | Get the static type of this expression
    `Expression` | `getNameExp()` | Get the expression used to compute the name of the attribute
    `Expression` | `getNamespaceExp()` | Get the expression used to compute the namespace part of the name of the attribute
    `NamespaceResolver` | `getNamespaceResolver()` | Get the namespace resolver used to resolve any prefix in the name of the attribute
    `boolean` | `isAllowNameAsQName()` | Ask whether it is allowed for the name to be evaluted as an xs:QName instance (true in XQuery)
    `void` | `localTypeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Method to perform type-checking specific to the kind of instruction
    `java.lang.Iterable<Operand>` | `operands()` | Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `Expression` | `optimize​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Perform optimisation of an expression and its subexpressions.
    `void` | `setNameExp​(Expression attributeName)` |
    `void` | `setNamespace​(Expression namespace)` |
    `void` | `setRejectDuplicates()` | Indicate that two attributes with the same name are not acceptable.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.AttributeCreator

      `getOptions, getSchemaType, getValidationAction, isInstruction, processValue, setInstruction, setNoSpecialChars, setOptions, setSchemaType, setValidationAction, validateOrphanAttribute`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.SimpleNodeConstructor

      `allowExtractingCommonSubexpressions, alwaysCreatesNewNodes, checkContent, computeCardinality, getSelect, getStreamerName, isLocal, iterate, mayCreateNewNodes, processLeavingTail, setSelect, typeCheck`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, getExpressionName, getImplementationMethod, getNetCost, getSourceLocator, isXSLT, process, someOperandCreatesNewNodes`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkedOperands, checkForUpdatingSubexpressions, computeDependencies, computeHashCode, computeStaticProperties, dynamicError, effectiveBooleanValue, equals, evaluatePendingUpdates, explain, getConfiguration, getCost, getDependencies, getEvaluationMethod, getExtraProperty, getIntegerBounds, getInterpretedExpression, getIntrinsicDependencies, getLocalRetainedStaticContext, getLocation, getObjectName, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getStaticUType, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, markTailFunctionCalls, operandList, operandSparseList, optimizeChildren, prepareForStreaming, resetLocalStaticProperties, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplify, simplifyChildren, staticTypeCheck, suppressValidation, toPattern, toShortString, toString, typeCheckChildren, typeError, unordered, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.trace.Traceable

      `gatherProperties`

- - ### Constructor Detail

    - #### ComputedAttribute

          public ComputedAttribute​(Expression attributeName,
                                   Expression namespace,
                                   NamespaceResolver nsContext,
                                   int validationAction,
                                   SimpleType schemaType,
                                   boolean allowNameAsQName)

      Construct an Attribute instruction
      Parameters:
        `attributeName` - An expression to calculate the attribute name
        `namespace` - An expression to calculate the attribute namespace
        `nsContext` - a NamespaceContext object containing the static namespace context of the stylesheet instruction
        `validationAction` - e.g. validation=strict, lax, strip, preserve
        `schemaType` - Type against which the attribute must be validated. This must not be a namespace-sensitive type; it is the caller's responsibility to check this.
        `allowNameAsQName` - true if the attributeName expression is allowed to evaluate to a value of type xs:QName (true in XQuery, false in XSLT)

  - ### Method Detail

    - #### setRejectDuplicates

          public void setRejectDuplicates()

      Indicate that two attributes with the same name are not acceptable. (This option is set in XQuery, but not in XSLT)
      Overrides:
        `setRejectDuplicates` in class `AttributeCreator`

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Get the name of this instruction
      Overrides:
        `getInstructionNameCode` in class `Instruction`
      Returns:
        a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

    - #### getNameExp

          public Expression getNameExp()

      Get the expression used to compute the name of the attribute
      Returns:
        the expression used to compute the name of the attribute

    - #### getNamespaceExp

          public Expression getNamespaceExp()

      Get the expression used to compute the namespace part of the name of the attribute
      Returns:
        the expression used to compute the namespace part of the name of the attribute

    - #### setNameExp

          public void setNameExp​(Expression attributeName)

    - #### setNamespace

          public void setNamespace​(Expression namespace)

    - #### operands

          public java.lang.Iterable<Operand> operands()

      Description copied from class: `Expression`
      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation works off the results of iterateSubExpressions()

      If the expression is a Callable, then it is required that the order of the operands returned by this function is the same as the order of arguments supplied to the corresponding call() method.

      Overrides:
        `operands` in class `SimpleNodeConstructor`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### getNamespaceResolver

          public NamespaceResolver getNamespaceResolver()

      Get the namespace resolver used to resolve any prefix in the name of the attribute
      Returns:
        the namespace resolver if one has been saved; or null otherwise

    - #### getItemType

          public ItemType getItemType()

      Get the static type of this expression
      Overrides:
        `getItemType` in class `AttributeCreator`
      Returns:
        the static type of the item returned by this expression

    - #### getCardinality

          public int getCardinality()

      Get the static cardinality of this expression
      Overrides:
        `getCardinality` in class `Expression`
      Returns:
        the static cardinality (exactly one)

    - #### isAllowNameAsQName

          public boolean isAllowNameAsQName()

      Ask whether it is allowed for the name to be evaluted as an xs:QName instance (true in XQuery)
      Returns:
        the boolean if name is allowed as a QName

    - #### computeSpecialProperties

          public int computeSpecialProperties()

      Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.
      Overrides:
        `computeSpecialProperties` in class `AttributeCreator`
      Returns:
        a set of flags indicating static properties of this expression

    - #### localTypeCheck

          public void localTypeCheck​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextItemType)
                              throws XPathException

      Description copied from class: `SimpleNodeConstructor`
      Method to perform type-checking specific to the kind of instruction
      Specified by:
        `localTypeCheck` in class `SimpleNodeConstructor`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of the context item
      Throws:
        `XPathException` - if a type error is detected

    - #### optimize

          public Expression optimize​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextItemType)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `SimpleNodeConstructor`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### copy

          public Expression copy​(RebindingMap rebindings)

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Parameters:
        `rebindings` - a mutable list of (old binding, new binding) pairs that is used to update the bindings held in any local variable references that are copied.
      Returns:
        the copy of the original expression

    - #### checkPermittedContents

          public void checkPermittedContents​(SchemaType parentType,
                                             boolean whole)
                                      throws XPathException

      Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.
      Overrides:
        `checkPermittedContents` in class `Expression`
      Parameters:
        `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
        `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
      Throws:
        `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

    - #### evaluateNodeName

          public NodeName evaluateNodeName​(XPathContext context)
                                    throws XPathException

      Determine the name to be used for the attribute, as an integer name code
      Overrides:
        `evaluateNodeName` in class `SimpleNodeConstructor`
      Parameters:
        `context` - Dynamic evaluation context
      Returns:
        the integer name code for the attribute name
      Throws:
        `XPathException` - if a dynamic error occurs (for example, if the attribute name is invalid)

    - #### evaluateItem

          public Item evaluateItem​(XPathContext context)
                            throws XPathException

      Description copied from class: `SimpleNodeConstructor`
      Evaluate as an expression.
      Overrides:
        `evaluateItem` in class `SimpleNodeConstructor`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### export

          public void export​(ExpressionPresenter out)
                      throws XPathException

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `export` in interface `ExportAgent`
      Specified by:
        `export` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure
      Throws:
        `XPathException` - if the export fails, for example if an expression is found that won't work in the target environment.